// ================================================================================================+
//                 =====              MaxiMiniBars_1.1.mq4                 =====                   |
//             =============          Copyright © 2022, Drknn          =============               |
//                 =====              mailto: drknn@mail.ru                =====                   |
// ================================================================================================+
#property copyright "Copyright 2022, DRKNN."
#property link      "drknn@mail.ru"
#property strict
string		ExpertName="MaxiMiniBars_1.1";
/*      =============== Техзадание ================
	Взято здесь: https://www.mql5.com/ru/forum/113987/page9#comment_3103325
	
	Всем здравствуйте. Подскажите пожалуйста есть ли советник по вот такой системе. Вроде она называется «следующий за трендом»
	• открытие длинной позиции производим, если цена закрытия выше максимальной цены за последние 20 бар;
	• закрытие длинной позиции производим, если цена закрытия ниже минимальной цены за последние 10 бар;
	• открытие короткой позиции производим, если цена закрытия ниже минимальной цены за последние 20 бар;
	• закрытие короткой позиции производим, если цена закрытия выше максимальной цены за последние 10 бар.
	Или может быть добрые люди помогут ее написать?
	
	Далее мне предложили перевернуть ордера (что в этой версии и реализовано):
	
*/

extern string   с1="-------- Первичные настройки --------";
extern double		StartLot=0.01;
extern int      HowManyChandleOpen=20;// Сколько свеч для открытия ордеров
extern int      HowManyChandleClose=10;// Сколько свеч для закрытия ордеров
extern string   с3=" -------- Прочие параметры --------";
extern int      MAGIC=1;//МагикНумбер
extern int      Proskalz=100;//Проскальзывание
// ----------- Вспомогательные переменные ---------------------------

string    SMB;
double    LOT,PR,SL,TP;
int       MinLevel,TicketBuy,TicketSell;
double		PriceUP,PriceDOWN,CloseUP,CloseDOWN;

// ================================================================================================+
// ================================================================================================|
//             =============          ИНИЦИАЛИЗАЦИЯ СОВЕТНИКА          =============               |
// ================================================================================================|
// ================================================================================================+
int init(){
  SMB=Symbol();
  return(0);
}
// ================================================================================================+
//             =============         ДЕИНИЦИАЛИЗАЦИЯ СОВЕТНИКА             =============           |
// ================================================================================================+
void OnDeinit(const int reason){
	DeinitComment(reason);
	Comment("");
}
// ================================================================================================+
//             =============         СТАРТ СОВЕТНИКА                       =============           |
// ================================================================================================+
void OnTick(){
	MinLevel=MarketInfo(SMB,MODE_STOPLEVEL);
	// ============= Отыскиваем уровни открытия ==========================
	PriceUP=0;PriceDOWN=20*Bid;
	for(int c=1;c<=1+HowManyChandleOpen;c++){
		if(High[c]>PriceUP){
				PriceUP=High[c];
		}
		if(Low[c]<PriceDOWN){
				PriceDOWN=Low[c];
		}
	}
	// ============= Отыскиваем уровни закрытия ==========================
	CloseUP=20*Bid;CloseDOWN=0;
	for(int cc=1;cc<=1+HowManyChandleClose;cc++){
		if(Low[cc]<CloseUP){
				CloseUP=Low[cc];
		}
		if(High[cc]>CloseDOWN){
				CloseDOWN=High[cc];
		}
	}
	// ============= Устанавливаем линии =====================  
	if(ObjectFind("LineUP")==(-1)){
		if(!ObjectCreate("LineUP",OBJ_HLINE,0,Time[0],PriceUP)){
			Alert("Ошибка № ",GetLastError()," при создании объекта LineUP");
		}
		else{
			ObjectSet("LineUP",OBJPROP_COLOR,Red);
			ObjectSet("LineUP",OBJPROP_WIDTH,1);
		}
	}
	
	if(ObjectFind("LineDOWN")==(-1)){
		if(!ObjectCreate("LineDOWN",OBJ_HLINE,0,Time[0],PriceDOWN)){
			Alert("Ошибка № ",GetLastError()," при создании объекта LineDOWN");
		}
		else{
			ObjectSet("LineDOWN",OBJPROP_COLOR,Blue);
			ObjectSet("LineDOWN",OBJPROP_WIDTH,1);
		}
	}
	//---------------------------------
	if(ObjectFind("CloseUP")==(-1)){
		if(!ObjectCreate("CloseUP",OBJ_HLINE,0,Time[0],CloseUP)){
			Alert("Ошибка № ",GetLastError()," при создании объекта CloseUP");
		}
		else{
			ObjectSet("CloseUP",OBJPROP_COLOR,DeepPink);
			ObjectSet("CloseP",OBJPROP_WIDTH,1);
		}
	}
	
	if(ObjectFind("CloseDOWN")==(-1)){
		if(!ObjectCreate("CloseDOWN",OBJ_HLINE,0,Time[0],CloseDOWN)){
			Alert("Ошибка № ",GetLastError()," при создании объекта CloseDOWN");
		}
		else{
			ObjectSet("CloseDOWN",OBJPROP_COLOR,DarkTurquoise);
			ObjectSet("CloseDOWN",OBJPROP_WIDTH,1);
		}
	}
	// ============= Перемещаем линии =====================
	if(ObjectFind("LineUP")>(-1)){
		if(ObjectGet("LineUP",OBJPROP_PRICE1)!=PriceUP){
			ObjectSet("LineUP",OBJPROP_PRICE1,PriceUP);
		}
	}
  if(ObjectFind("LineDOWN")>(-1)){
		if(ObjectGet("LineDOWN",OBJPROP_PRICE1)!=PriceDOWN){
			ObjectSet("LineDOWN",OBJPROP_PRICE1,PriceDOWN);
		}
	}
	//-------------------
	if(ObjectFind("CloseUP")>(-1)){
		if(ObjectGet("CloseUP",OBJPROP_PRICE1)!=CloseUP){
			ObjectSet("CloseUP",OBJPROP_PRICE1,CloseUP);
		}
	}
  if(ObjectFind("CloseDOWN")>(-1)){
		if(ObjectGet("CloseDOWN",OBJPROP_PRICE1)!=CloseDOWN){
			ObjectSet("CloseDOWN",OBJPROP_PRICE1,CloseDOWN);
		}
	}
	// ============== Ставим ордера ==================
	if(SchSell(MAGIC)<=0){
		PR=NormalizeDouble(ObjectGet("LineUP",OBJPROP_PRICE1),Digits);
		if(Bid>PR){
			LOT=ProverkaLota(StartLot);
			SL=0;
			TP=0;
			TicketSell=OrderSend(SMB,OP_SELL,LOT,Bid,Proskalz,SL,TP,NULL,MAGIC,0,CLR_NONE);
			if(TicketSell<0){
				Print("Bid = ",Bid," SL= ",SL," TP = ",TP," MinLevel = ",MinLevel);
				Print("Ошибка № ",GetLastError()," при установке Sell-ордера");
			}
		}
	}
	if(SchBuy(MAGIC)<=0){
		PR=NormalizeDouble(ObjectGet("LineDOWN",OBJPROP_PRICE1),Digits);
		if(Ask<PR){
			LOT=ProverkaLota(StartLot);
			SL=0;
			TP=0;
			TicketBuy=OrderSend(SMB,OP_BUY,LOT,Ask,Proskalz,SL,TP,NULL,MAGIC,0,CLR_NONE);
			if(TicketBuy<0){
				Print("Ask = ",Ask," SL= ",SL," TP = ",TP," MinLevel = ",MinLevel);
				Print("Ошибка № ",GetLastError()," при установке Buy-ордера");
			}
		}
	}
	// =============== Закрываем ордера ================
	if(SchSell(MAGIC)>0){
		PR=NormalizeDouble(ObjectGet("CloseUP",OBJPROP_PRICE1),Digits);
		if(Ask<PR){
			Close_All_Sell(MAGIC,Proskalz);
		}
	}
	if(SchBuy(MAGIC)>0){
		PR=NormalizeDouble(ObjectGet("CloseDOWN",OBJPROP_PRICE1),Digits);
		if(Bid>PR){
			Close_All_Buy(MAGIC,Proskalz);
		}
	}
	
}
//+------------------------------------------------------------------+
//|              Пользовательские подпрограммы                       |
//+------------------------------------------------------------------+
// =================== Close_All_Buy() =======================
// функция закрывает все рыночные и отложенные ордера
// ===========================================================
void Close_All_Buy(int Magic, int Prosk){
	string	FunctionName="Close_All_Buy()";
	int			Ticket=0;
	double	PriseBid=0;
	double	Lot=0;
	for(int i=OrdersTotal()-1;i>=0;i--){
		if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
			Print("Ошибка произошла в функции ",FunctionName);
		}
		else{
			if(OrderSymbol()!=SMB || OrderMagicNumber()!=Magic){continue;}
			RefreshRates();
			PriseBid=NormalizeDouble(Bid,Digits); 
			Ticket=OrderTicket();
			Lot=OrderLots();
			if(OrderType()==OP_BUY){
				if(!OrderClose(Ticket,Lot,PriseBid,Prosk,CLR_NONE)){
					Print("Ошибка № ",GetLastError()," при закрытии ордера № ",Ticket);
				}
			}  
		}
	}
}

// =================== Close_All_Sell() =======================
// функция закрывает все рыночные и отложенные ордера
// ===========================================================
void Close_All_Sell(int Magic, int Prosk){
	string	FunctionName="Close_All_Sell()";
	int			Ticket=0;
	double	PriseAsk=0;
	double	Lot=0;
	for(int i=OrdersTotal()-1;i>=0;i--){
		if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
			Print("Ошибка произошла в функции ",FunctionName);
		}
		else{
			if(OrderSymbol()!=SMB || OrderMagicNumber()!=Magic){continue;}
			RefreshRates();
			PriseAsk=NormalizeDouble(Ask,Digits); 
			Ticket=OrderTicket();
			Lot=OrderLots();
			if(OrderType()==OP_SELL){
				if(!OrderClose(Ticket,Lot,PriseAsk,Prosk,CLR_NONE)){
					Print("Ошибка № ",GetLastError()," при закрытии ордера № ",Ticket);
				}
			}  
		}
	}
}
// ============ ProverkaLota() =====================================================================
// функция принимает нормализует лот ордера
//-----------------------------------------------------
double ProverkaLota(double LotOrdera){
  string Temp;
  double MinLots=(MarketInfo(SMB,MODE_MINLOT));
  double MaxLots=MarketInfo(SMB,MODE_MAXLOT);
  double CorrectLot=0;
  int    diglots=0;
  if(MinLots==1 || MinLots==0.1 || MinLots==0.01){
		if(MinLots==1){
			diglots=0;
		}
		if(MinLots==0.1){
			diglots=1;
		}
		if(MinLots==0.01){
			diglots=2;
		}
	}
	Temp=DoubleToStr(LotOrdera,diglots);// отбрасываем лишние числа
	CorrectLot=StrToDouble(Temp);
  if(CorrectLot<MinLots){
    CorrectLot=MinLots;
  }
  if(CorrectLot>MaxLots){
    CorrectLot=MaxLots;
  }
  return(CorrectLot);
}
//=========== SchBuy()  ===============================
//  Функция возвращает количество Buy-ордеров
//   SchBuy      - счётчик Buy ордеров
//-----------------------------------------------------------
int SchBuy(int Magic){
  string NameFunction="SchBuy()";
  int SchBuy=0;
  int i;
  for (i=OrdersTotal()-1;i>=0;i--) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
			Print(" ============== ",NameFunction," ============== ");
		}
    else {
      if(OrderSymbol()!= SMB || OrderMagicNumber()!= Magic){continue;}
      if(OrderType()==OP_BUY){ 
        SchBuy++;
      }  
    }
  }
  return(SchBuy);
}                  
//==================================================================================================


//=========== SchSell()  ===============================
//  Функция возвращает количество Sell-ордеров
//  SchSell  - счётчик Sell ордеров
//-----------------------------------------------------------
int SchSell(int Magic){
  string NameFunction="SchSell()";
   int SchSell=0;
  int i;
  for (i=OrdersTotal()-1;i>=0;i--){
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			Print("Ошибка № ",GetLastError()," при выборе ордера № ",i);
			Print(" ============== ",NameFunction," ============== ");
		}
    else {
      if(OrderSymbol()!=SMB || OrderMagicNumber()!=Magic){continue;} 
      if(OrderType()==OP_SELL){
        SchSell++;
      }
    }
  }
 return(SchSell);     
}  
               
//======================================================
// ================ Деинициализация ================================================================
void DeinitComment(int Prichina){
	if(!IsTesting()){
		string s_Deint;
		switch (Prichina){
			case 0: s_Deint="Эксперт прекратил свою работу, вызвав функцию ExpertRemove()"; break;
			case 1: s_Deint="Советник удалён с графика либо вручную, либо на график был брошен другой эксперт, что привело к удалению данного"; break;
			case 2: s_Deint="Советник перекомпилирован"; break;
			case 3: s_Deint="Символ или период графика был изменен"; break;
			case 4: s_Deint="График закрыт, либо трейдер сменил шаблон графика"; break;
			case 5: s_Deint="Входные параметры были изменены пользователем"; break;
			case 6: s_Deint="Активирован другой счет либо произошло переподключение к торговому серверу вследствие изменения настроек счета"; break;
			case 7: s_Deint="Применён другой шаблон графика"; break;
			case 8: s_Deint="Признак того, что обработчик OnInit() вернул ненулевое значение"; break;
			case 9: s_Deint="Терминал был закрыт"; break;
			default: s_Deint="Причина деинициализации не ясна"; break;
		}
		Print("Советник ",ExpertName," на инструменте ",Symbol()," деинициализирован. Причина: ",s_Deint);
	}
}
